unit GamecreatorUnit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, Buttons, Menus, MPlayer, Gauges,jpeg;

type

  T_Dzeiger = ^T_Datei;
  T_Datei= RECORD
            name  : string;
            zeiger: T_Dzeiger;
          END;

  TMainForm = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    Label1: TLabel;
    EndeSpeedButton2: TSpeedButton;
    optionenSpeedButton3: TSpeedButton;
    HilfeSpeedButton4: TSpeedButton;
    BonnImage1: TImage;
    ZielLabel: TLabel;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    KiTimer1: TTimer;
    PopupMenu1: TPopupMenu;
    Ende1: TMenuItem;
    Label3: TLabel;
    Label4: TLabel;
    PunkteLabel5: TLabel;
    MediaPlayer1: TMediaPlayer;
    Label6: TLabel;
    EditorSpeedButton: TSpeedButton;
    Label7: TLabel;
    Label2: TLabel;
    Abschuss2Label: TLabel;
    Abschuss2Image: TImage;
    SchussImage: TImage;
    SchussTimer: TTimer;
    Menue: TMenuItem;
    weiter1: TMenuItem;
    energieGauge: TGauge;
    MediaPlayer2: TMediaPlayer;
    hbildImage: TImage;
    Panel3: TPanel;
    StartSpeedButton1: TSpeedButton;
    ExtraSpeedButton: TSpeedButton;
    procedure FormResize(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure StartSpeedButton1Click(Sender: TObject);
    procedure EndeSpeedButton2Click(Sender: TObject);
    procedure optionenSpeedButton3Click(Sender: TObject);
    procedure HilfeSpeedButton4Click(Sender: TObject);
    procedure KiTimer1Timer(Sender: TObject);
    procedure Image1Click(Sender: TObject);
    procedure Ende1Click(Sender: TObject);
    procedure EditorSpeedButtonClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormCreate(Sender: TObject);
    procedure dateischreiben(datei: string);
    procedure dateischreibensetup;    
    procedure transparentabschuss;
    procedure transparentziel;
    procedure Abschuss2ImageClick(Sender: TObject);
    procedure SchussTimerTimer(Sender: TObject);
    procedure weiter1Click(Sender: TObject);
    procedure MenueClick(Sender: TObject);
    procedure dateiexlesen(datei : string);
    procedure ExtraSpeedButtonClick(Sender: TObject);
    procedure neudateieintrag(name: string );
    procedure suchevornach(inhalt: string; VAR vorgaenger, nachfolger: t_Dzeiger);
    procedure Label7Click(Sender: TObject);
    procedure Label7MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);

  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

PROCEDURE Zentriert;
PROCEDURE Start;
PROCEDURE Standort;
PROCEDURE Bewegung;
PROCEDURE Punkt;
PROCEDURE PlaySound(SoundID : INTEGER; Play : BOOLEAN = TRUE);

FUNCTION Ende : Boolean;

var
  MainForm: TMainForm;

{-------------allgemeine Records---------------- }
TYPE
   T_Highscore= RECORD
               Punkte            : integer;
               name              : string;
               schwierigkeitsgrad: integer;
             END;
   T_Highscores = Array[1..10] of T_highscore;

  { T_Dzeiger = ^T_Datei ....     siehe oben}

{------------allgemeine Variablen-----------}
var
 cfg                               : Textfile;
 ziel,abschuss, abschuss2,schuss,
 titel,zielort, hfarbe, textfarbe,
 abschuss2ort, hbild, spielername,
 startbutton                       : string;
 beschriftung, bilder, sonstiges   : Array[1..30] of string;
 abschuss2sichtbar, zielsichtbar,
 abschusstransp, zieltransp,
 schusstransp, abschuss2transp,
 anaus,hbildanaus                  : string;
 schwierigkeitsgrad                : integer;
 //dateinamen                        : Array of string;
 //dateianzahl,dateiaktuell          : integer;
 dateiaktuell                      : string;
 usedatei                          : T_Dzeiger;
 SoundFile                         : ARRAY OF STRING;
 soundanzahl                       : integer;
 Spezialsoundfile                  : Array[1..4] of string;
 {1=verloren, 2=sieg, 3=explosion, 4=schussstart}
 highscore                         : T_highscores;

{-----------Ende allgemeiner Variablen------}

implementation

uses Unit1, HilfeUnit2, optionenUnit2, extrasUnit2, ShellAPI;

{$R *.DFM}
CONST
      SLost  = 1;
      SWin   = 2;
      SExpl  = 3;
      SSchuss= 4;
var
  stop, erstemal      : boolean;
  ImageActive         : ARRAY [1..4] OF Boolean;
  Treffer,bild,
  punkte, sieg,
  schaden             : integer;

{Open Source Program by MD-Technologie}
{Code optimized by Provocation Interactive}

{------------allgemeine eigene Proceduren-------------------------}


procedure TMainForm.dateischreiben(datei : string);
 var i,j: integer;
begin
 {begin vom Speicherstand }
   Assignfile(cfg,extractfiledir(application.exename)+'\'+datei+'.cfg');
   ReWrite(cfg);
   Append(cfg);
   WriteLN(cfg,'GameCreator, Copyright by MD');
   WriteLN(cfg,'Manuelle nderungen der Datei auf eigene Gefahr!');
   WriteLN(cfg);
   WriteLN(cfg,'Bilder:');

   i:=0;
   Repeat
    inc(i);
    WriteLN(cfg,bilder[i]);
   until bilder[i]='';
   {duch letzten leeren array wird leerzeile erzeugt}

   WriteLN(cfg,'Beschriftung:');
   i:=0;
   Repeat
    inc(i);
    WriteLN(cfg,beschriftung[i]);
   until beschriftung[i]='';
   {duch letzten leeren array wird leerzeile erzeugt}
  // if abschuss2sichtbar <> '' then WriteLN(cfg,'Abschuss2 sichtbar: '+abschuss2sichtbar);
   WriteLN(cfg,'Spielername: '+spielername);
   WriteLN(cfg,'Schwierigkeitsgrad: '+inttostr(schwierigkeitsgrad));

   Write(cfg,'Highscore: ');
   for i:=1 to 10 do
    begin
     Write(cfg,highscore[i].name+';');
     Write(cfg,highscore[i].punkte); write(cfg,';');
     Write(cfg,highscore[i].schwierigkeitsgrad); write(cfg,';');
    end;

   WriteLN(cfg);
   WriteLN(cfg);
   WriteLN(cfg,'Sounddateien:');
   WriteLN(cfg,'Sounddateianzahl: '+inttostr(soundanzahl));

   for i:=0 to soundanzahl-1 do WriteLN(cfg,'Sounds: '+SoundFile[i]);

   WriteLN(cfg,'Verlorensound: '+spezialsoundfile[1]);
   WriteLN(cfg,'Siegsound: '+spezialsoundfile[2]);
   WriteLN(cfg,'Explosionssound: '+spezialsoundfile[3]);
   WriteLN(cfg,'Schussstartsound: '+spezialsoundfile[4]);

   WriteLN(cfg);

   WriteLN(cfg,'Andere Einstellungen:');
   i:=0;
   Repeat
    inc(i);
    WriteLN(cfg,sonstiges[i]);
   until sonstiges[i]='';
   {duch letzten leeren array wird leerzeile erzeugt}

   WriteLN(cfg,'www.md-technologie.de');
   WriteLN(cfg,'Ende :-)');

   CloseFile(cfg);
 {ende vom Speicherstand }
   Mainform.dateischreibensetup;
end;

procedure TMainForm.dateischreibensetup;
 var use: T_Dzeiger;
begin
 {begin von der setupdatei}
   Assignfile(cfg,extractfiledir(application.exename)+'\setup.cfg');
   ReWrite(cfg);
   Append(cfg);

   WriteLN(cfg,'GameCreator, Copyright by MD');
   WriteLN(cfg,'Manuelle nderungen der Datei auf eigene Gefahr!');
   WriteLN(cfg);
   WriteLN(cfg,'Speicherstnde');
   WriteLN(cfg,'Spielstart: '+dateiaktuell);

   use:=usedatei;
   while use<>nil do   {schreibt alle Eintrge neu, den zeigern folgend}
   begin
     WriteLN(cfg,'Speicherstand: '+use^.name);
     use:=use^.zeiger;
   end;

   WriteLN(cfg);

   WriteLN(cfg,'Ende =:-)');

   CloseFile(cfg);
  {ende der setupdatei}
end;

procedure TMainForm.transparentabschuss;
 var i: integer;
begin
 if abschusstransp='false' then
  begin
   for i:=1 to 5 do begin
   MainForm.Image1.transparent:=false;
   MainForm.Image2.transparent:=false;
   MainForm.Image3.transparent:=false;
   MainForm.Image4.transparent:=false;
//   (MainForm.Components[i] as TImage).transparent:=false;

   end;
//   Editorform.AbschussImage.transparent:=false;
  end;
end;

procedure TMainForm.transparentziel;
begin
 if zieltransp='false' then
  begin
   MainForm.Bonnimage1.transparent:=false;
//   editorform.ZielImage.transparent:=false;
  end;
end;

{---------------Ende eigener allgemeiner Proceduren-------------}


{---------------eigene Proceduren--------------}

procedure dateineu;
var i : integer;
begin

 Assignfile(cfg,extractfiledir(application.exename)+'\standard.cfg');
 ReWrite(cfg);
 Append(cfg);

 WriteLN(cfg,'GameCreator, Copyright by MD');
 WriteLN(cfg,'Manuelle nderungen der Datei auf eigene Gefahr!');
 WriteLN(cfg);
 WriteLN(cfg,'Bilder:');
 WriteLN(cfg,'Ziel: '+ extractfiledir(application.exename)+'\Standard\bilder\ziel.bmp');
 WriteLN(cfg,'Abschuss: '+ extractfiledir(application.exename)+'\Standard\bilder\abschuss.bmp');
 WriteLN(cfg,'Abschuss2: '+ extractfiledir(application.exename)+'\Standard\bilder\abschuss2.bmp');
 WriteLN(cfg,'Schuss: '+ extractfiledir(application.exename)+'\Standard\bilder\schuss.bmp');
 WriteLN(cfg,'Hintergrundfarbe: 0');
 WriteLN(cfg,'Textfarbe: 12632256');
 WriteLN(cfg,'Hintergrundbild: '+ extractfiledir(application.exename)+'\Standard\bilder\hbild.jpg');
 WriteLN(cfg);
 WriteLN(cfg,'Beschriftung:');
 WriteLN(cfg,'Titel: Alien');
 WriteLN(cfg,'Zielort: Erde');
 WriteLN(cfg,'Abschuss2ort: Mutterschiff');
 WriteLN(cfg,'Startbutton: Start');
 WriteLN(cfg);
 WriteLN(cfg,'Spielername: Spieler');
 WriteLN(cfg,'Highscore: MD-Technologie;110;1;MD-Technologie;12;1;MD-Technologie;10;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;');
 WriteLN(cfg,'Schwierigkeitsgrad: 1');
 WriteLN(cfg);

  for i:= 0 to 9 do
   begin
    Soundfile[i]:=ExtractFileDir(Application.EXEName) + '\Standard\sound\au' + inttostr(i+1) + '.wav';
   end;
 WriteLN(cfg,'Sounddateien:');
 WriteLN(cfg,'Sounddateianzahl: 10');
 for i:=0 to 9 do WriteLN(cfg,'Sounds: '+soundfile[i]);

 WriteLN(cfg,'Verlorensound: '+ExtractFileDir(Application.EXEName) + '\Standard\sound\verloren.wav');
 WriteLN(cfg,'Siegsound: '+ExtractFileDir(Application.EXEName) + '\Standard\sound\sieg.wav');
 WriteLN(cfg,'Explosionssound: '+ExtractFileDir(Application.EXEName) + '\Standard\sound\explosion.wav');
 WriteLN(cfg,'Schussstartsound: '+ExtractFileDir(Application.EXEName) + '\Standard\sound\schussstart.wav');

 WriteLN(cfg);
 WriteLN(cfg,'Andere Einstellungen:');

 WriteLN(cfg);
 WriteLN(cfg,'Ende :-)');
 CloseFile(cfg);

 Assignfile(cfg,extractfiledir(application.exename)+'\setup.cfg');
 ReWrite(cfg);
 Append(cfg);
 WriteLN(cfg,'GameCreator, Copyright by MD');
 WriteLN(cfg,'Manuelle nderungen der Datei auf eigene Gefahr!');
 WriteLN(cfg);
 WriteLN(cfg,'Speicherstnde');
 WriteLN(cfg,'Spielstart: Standard');
 WriteLN(cfg,'Speicherstand: Standard');
 WriteLN(cfg);

 WriteLN(cfg,'Ende =:-)');
 CloseFile(cfg);
end;

procedure TMainform.suchevornach(inhalt: string; VAR vorgaenger, nachfolger: t_Dzeiger);
var gefunden : boolean;
begin
 vorgaenger:=nil;
 nachfolger:=usedatei;
 gefunden:=false;

 While (nachfolger<>nil) and not gefunden do
  if lowercase(nachfolger^.name) < lowercase(inhalt) then
   begin
    vorgaenger := nachfolger;
    nachfolger := nachfolger^.zeiger;
   end
   else gefunden:=true;
end;

procedure TMainform.neudateieintrag( name: string );
var vor, nach, neu : t_Dzeiger;
begin  {fgt neuen Eintrag hinzu. Neuer Eintrag ist erster Eintrag.}
  Mainform.suchevornach(name,vor,nach);
  new(neu);
  neu^.name:=name;
  neu^.zeiger:=nach;
  if vor=nil then usedatei:=neu else vor^.zeiger:=neu;
end;

procedure dateilesen(name: string);
 var eingelesen, dateinametemp : string;
     i,j,k                   : integer;

 procedure ausgabe( pruefen :string);
 var f : integer;
  begin
   if copy(pruefen,1,6) ='Ziel: ' then ziel:=copy(pruefen,7,length(pruefen));
   if copy(pruefen,1,10)='Abschuss: ' then abschuss:=copy(pruefen,11,length(pruefen));
   if copy(pruefen,1,18)='Hintergrundfarbe: ' then hfarbe:=copy(pruefen,19,length(pruefen));
   if copy(pruefen,1,11)='Textfarbe: ' then textfarbe:=copy(pruefen,12,length(pruefen));
   if copy(pruefen,1,7) ='Titel: ' then titel:=copy(pruefen,8,length(pruefen));
   if copy(pruefen,1,9) ='Zielort: ' then zielort:=copy(pruefen,10,length(pruefen));
   if copy(pruefen,1,14)='Abschuss2ort: ' then abschuss2ort:=copy(pruefen,15,length(pruefen));
   if copy(pruefen,1,17)='Hintergrundbild: ' then hbild:=copy(pruefen,18,length(pruefen));
   if copy(pruefen,1,22)='Abschuss Transparent: ' then abschusstransp:=copy(pruefen,23,length(pruefen));
   if copy(pruefen,1,18)='Ziel Transparent: ' then zieltransp:=copy(pruefen,19,length(pruefen));
   if copy(pruefen,1,24)='Abschuss2text sichtbar: ' then abschuss2sichtbar:=copy(pruefen,25,length(pruefen));
   if copy(pruefen,1,19)='Zieltext sichtbar: ' then zielsichtbar:=copy(pruefen,20,length(pruefen));
   if copy(pruefen,1,11)='Abschuss2: ' then abschuss2:=copy(pruefen,12,length(pruefen));
   if copy(pruefen,1,8) ='Schuss: ' then schuss:=copy(pruefen,9,length(pruefen));
   if copy(pruefen,1,11)='Ab2 aktiv: ' then anaus:=copy(pruefen,12,length(pruefen));
   if copy(pruefen,1,20)='Schuss Transparent: ' then schusstransp:=copy(pruefen,21,length(pruefen));
   if copy(pruefen,1,23)='Abschuss2 Transparent: ' then abschuss2transp:=copy(pruefen,24,length(pruefen));
   if copy(pruefen,1,27)='Hintergrundbild aktiviert: ' then hbildanaus:=copy(pruefen,28,length(pruefen));
   if copy(pruefen,1,18)='Sounddateianzahl: ' then
      begin
       soundanzahl:=strtoint(copy(pruefen,19,length(pruefen)));
       SetLength(SoundFile,soundanzahl);
      end;
   if copy(pruefen,1,8)='Sounds: ' then
       begin
        SoundFile[i]:=copy(pruefen,9,length(pruefen));
        inc(i);
       end;
   if copy(pruefen,1,15)='Verlorensound: ' then spezialsoundfile[1]:=copy(pruefen,16,length(pruefen));
   if copy(pruefen,1,11)='Siegsound: ' then spezialsoundfile[2]:=copy(pruefen,12,length(pruefen));
   if copy(pruefen,1,17)='Explosionssound: ' then spezialsoundfile[3]:=copy(pruefen,18,length(pruefen));
   if copy(pruefen,1,18)='Schussstartsound: ' then spezialsoundfile[4]:=copy(pruefen,19,length(pruefen));
   if copy(pruefen,1,12)='Spielstart: ' then
    if erstemal then dateiaktuell:=copy(pruefen,13,length(pruefen));
   if copy(pruefen,1,15)='Speicherstand: ' then Mainform.neudateieintrag(copy(pruefen,16,length(pruefen)));
   if copy(pruefen,1,13)='Spielername: ' then spielername:=copy(pruefen,14,length(pruefen));
   if copy(pruefen,1,11)='Highscore: ' then
       begin
        pruefen:=copy(pruefen,12,length(pruefen));
        for f:=1 to 10 do
        begin
         highscore[f].name:=copy(pruefen,1,pos(';',pruefen)-1);
         pruefen:=copy(pruefen,pos(';',pruefen)+1,length(pruefen));
         highscore[f].punkte:=strtoint(copy(pruefen,1,pos(';',pruefen)-1));
         pruefen:=copy(pruefen,pos(';',pruefen)+1,length(pruefen));
         highscore[f].schwierigkeitsgrad:=strtoint(copy(pruefen,1,pos(';',pruefen)-1));
         pruefen:=copy(pruefen,pos(';',pruefen)+1,length(pruefen));
        end;
       end;
   if copy(pruefen,1,20)='Schwierigkeitsgrad: ' then schwierigkeitsgrad:=strtoint(copy(pruefen,21,length(pruefen)));
   if copy(pruefen,1,13)='Startbutton: ' then startbutton:=copy(pruefen,14,length(pruefen));
  end;

 begin
 usedatei:=nil;
 dateinametemp:=name;
 name:='setup';
 for j:=1 to 2 do
 begin
  i:=0;
  Assignfile(cfg,extractfiledir(application.exename)+'\'+name+'.cfg');
  if not FileExists(extractfiledir(application.exename)+'\'+name+'.cfg') then
  begin
   Dateineu;
   Assignfile(cfg,extractfiledir(application.exename)+'\'+name+'.cfg');
  end;
//  showmessage('Datei '+name);
  Reset(cfg);
  if seekEoF(cfg)=true then
    begin
     closefile(cfg);
     showmessage('Die Setup-Datei ist fehlerhaft. Alle Einstellungen werden auf Standart zurckgesetzt.');
     Dateineu;
     Reset(cfg);
    end;                          {Wenn Datei leer ist, schreibe neu}

  repeat                          { Hauptleseprozedur }
   ReadLN(cfg,eingelesen);
   ausgabe(eingelesen);
  until SeekEof(cfg);

  closefile(cfg);

  if erstemal then
   begin
    dateinametemp:=dateiaktuell;
    erstemal:=false;
   end;

  name:=dateinametemp;

  k:=0;
 end;

 with Mainform do
  begin
   if (abschuss='') or (zielort='') or (ziel='') or (titel='')
   or (spielername='') or (soundfile[1]='') or (textfarbe='')
   then
    begin
     showmessage('Die Szenario-Datei ist fehlerhaft. Alle Einstellungen werden auf Standart zurckgesetzt.');
     Dateineu;
     dateilesen('standard');
    end;
  end; {berprft, ob alle wichtigen Variablen ihren Wert haben}

end;

{ allgemene Procedur, greift auf dateilesen zu, muss daher darunter stehen}
procedure TMainForm.dateiexlesen(datei : string);
{ zum aufruf von dateilesen von auerhalb}
begin
 dateilesen(datei);
end;



procedure zentriert;
var
  pan : integer;
begin
 pan:=MainForm.panel1.width div 2;
 WITH MainForm DO BEGIN
   panel2.left:=pan-(panel2.width div 2);
   panel2.width:=label2.width+20;
   panel3.left:=pan-(panel3.width div 2);
   label1.left:=(panel2.width div 2)-(label1.width div 2);
   EditorSpeedButton.left:=pan-(editorSpeedButton.width div 2);
   EndeSpeedButton2.left:=pan-(EndeSpeedButton2.width div 2);
   HilfeSpeedButton4.left:=pan-(HilfeSpeedButton4.width div 2);
   OptionenSpeedButton3.left:=pan-(OptionenSpeedButton3.width div 2);
   Label6.left:=pan-(label6.width div 2);
   Label7.top:=panel1.height-20;
   Label7.left:=pan-(label7.width div 2);
   //Logoimage.left:=pan-(Logoimage.width div 2);
 END;
end;

PROCEDURE PlaySound(SoundID : INTEGER; Play : BOOLEAN = TRUE);
BEGIN
  MainForm.MediaPlayer1.FileName := SoundFile[SoundID];
  MainForm.MediaPlayer1.Open;
  IF Play THEN MainForm.MediaPlayer1.Play;
END;

PROCEDURE PlaySound2(SoundID : INTEGER; Play : BOOLEAN = TRUE);
BEGIN
  MainForm.MediaPlayer2.FileName := SpezialSoundFile[SoundID];
  MainForm.MediaPlayer2.Open;
  IF Play THEN MainForm.MediaPlayer2.Play;
END;


FUNCTION GetObject(Number : INTEGER): TObject;
BEGIN
  GetObject := MainForm.Components[Number + 3];
END;


PROCEDURE Standort;
VAR I, Direction : INTEGER;
BEGIN
  FOR I := 1 TO 4 DO IF ImageActive[I] THEN BEGIN
    Randomize;
    Direction := Random(2);
    (GetObject(I) AS TImage).Top  := 0;
    (GetObject(I) AS TImage).Left := 0;
    IF Direction = 1 THEN (GetObject(I) AS TImage).Left := Random(MainForm.Width-100)
                     ELSE (GetObject(I) AS TImage).Top  := Random(MainForm.Height-100);
    (GetObject(I) AS TImage).Visible := True;
    ImageActive[I] := False;
  END;
END;


FUNCTION Ende : Boolean;
VAR I : INTEGER;
BEGIN
  Ende := FALSE;
  FOR I := 1 TO 4 DO IF ((GetObject(I) AS TImage).Left >= MainForm.BonnImage1.Left + {50}(Mainform.bonnimage1.width div 2))
   AND ((GetObject(I) AS TImage).Top >= MainForm.BonnImage1.Top + {50}(Mainform.bonnimage1.height div 2)) THEN Ende := TRUE;
END;

Procedure start;
VAR I : INTEGER;
begin
 dateilesen(dateiaktuell);
 WITH MainForm DO BEGIN
   KiTimer1.Interval:=100;

   cursor:=crcross;
   transparentabschuss;   {setzt die Abschubilder gegebenfalls transparent}
   transparentziel;       {setzt Bonnimage gegebenfalls transparent}  {der Name Bonnimage ist ein berbleibsel aus den Anfngen des Programms}

   Image1.Picture.LoadFromFile(abschuss);
   BonnImage1.Picture.LoadFromFile(ziel);
   Abschuss2Image.Picture.LoadFromFile(abschuss2);
   SchussImage.Picture.LoadFromFile(schuss);
   if hbildanaus='' then
   begin
    hbildimage.picture.LoadFromFile(hbild);
    hbildimage.visible:=true;
   end;

   punkte:=0;
   treffer:=0;
   sieg:=0;
    case schwierigkeitsgrad of
    1 : schaden:=10;
    2 : schaden:=12;
    3 : schaden:=14;
    4 : schaden:=16;
    5 : schaden:=20;
    end;

   bild:=0;
   //Label2.caption:=titel;

   label3.font.color:=strtoint(textfarbe);
   label4.font.color:=strtoint(textfarbe);
   punktelabel5.font.color:=strtoint(textfarbe);
   ZielLabel.caption:=zielort;
   Ziellabel.font.color:=strtoint(textfarbe);
   abschuss2label.caption:=abschuss2ort;
   abschuss2label.Font.color:=strtoint(textfarbe);
   energieGauge.maxvalue:=schaden;
   energieGauge.progress:=schaden;
   energieGauge.width:=abschuss2image.Width;
   energiegauge.forecolor:=cllime;

   transparentabschuss;
   transparentziel;
   PlaySound(0, FALSE);
   playsound2(2, False);
   label3.left:=1;
   label3.top:=1;  {beenden durch Rechtsklick}
   Panel1.visible:=false;
   Color:=strtoint(hfarbe);
   BonnImage1.visible:=true;
   ziellabel.visible:=true;
   for i:=2 to 4 do
    begin
     (getobject(i) as Timage).picture:=image1.picture;
    end;

   if not (hbildanaus='false') then
   begin
    hbildimage.Width:=screen.DesktopWidth; hbildimage.height:=screen.DesktopHeight;
    hbildimage.top:=1; hbildimage.left:=1;
   end;

   KiTimer1.enabled:=true;

   label4.top:=1;
   label4.left:=(width div 2)-(label4.width div 2)-20;
   PunkteLabel5.top:=1;
   Punktelabel5.left:=label4.left+43;
   Punktelabel5.caption:='0';
   borderstyle:=bsnone;


   if not (hbildanaus='false') then
    if not((hbildimage.width=Screen.width) and (hbildimage.Height=screen.height)) then
     begin
      Mainform.width:=hbildimage.width;
      Mainform.height:=hbildimage.Height;
      Mainform.left:=(Screen.width div 2)-(Mainform.width div 2);
      Mainform.top:=(screen.height div 2)-(mainform.Height div 2);
     end else windowstate:=wsmaximized
    else windowstate:=wsmaximized;

   if anaus='false' then
    begin
     Abschuss2image.visible:=false;
     SchussImage.visible:=false;
     energiegauge.visible:=false;
     abschuss2label.visible:=false;
    end else
    begin
     abschuss2image.visible:=true;
     energiegauge.visible:=true;
     abschuss2label.visible:=true;
    end;
   if zielsichtbar='false' then ziellabel.visible:=false else ziellabel.visible:=true;
   //ziellabel.visible:=zielsichtbar='false';
   if abschuss2sichtbar='false' then abschuss2label.visible:=false else abschuss2label.visible:=true;
   //abschuss2label.visible:=abschuss2sichtbar='false';
   if schusstransp='false' then schussimage.transparent:=false else schussimage.transparent:=true;
   //schussimage.transparent:=schusstransp='false';
   if abschuss2transp='false' then abschuss2image.transparent:=false else abschuss2image.transparent:=true;
   //abschuss2image.transparent:=abschuss2transp='false';
 END;

 ImageActive[1]:=true;
 FOR I := 2 TO 4 DO ImageActive[I]:=False;

 stop:=false;
end;

procedure ZumMenue;
 var i: integer;
begin
 with Mainform do
 begin
  KiTimer1.enabled:=false;
  schussTimer.enabled:=false;
  panel1.visible:=true;
  windowstate:=wsnormal;
  borderstyle:=bsSizeable;
  for i:=1 to 4 do
   begin
    (getobject(I) as Timage).visible:=false;
    (getobject(I) as Timage).left:=0;
    (getobject(I) as Timage).top:=0;
   end;
  mediaplayer1.close;
  mediaplayer2.close;
  schussimage.visible:=false;
  hbildimage.visible:=false;
  zentriert;
  Mainform.width:=630;
  Mainform.height:=500;
  Mainform.top:=(screen.height div 2)-(mainform.Height div 2);
  Mainform.left:=(Screen.width div 2)-(Mainform.width div 2);
 end;
end;

{procedure bubblesort( VAR namen: T_highscores; anzahl: integer);
 var i,ende : integer;
     sortiert : boolean;
     puffer : T_highscore;
begin
 i:=0;
 sortiert:=false;
 ende:=0;
 repeat
  i:=0;
  sortiert:=true;
  repeat
   inc(i);
    if namen[i].punkte<namen[i+1].punkte then
     begin
      puffer:=namen[i];
      namen[i]:=namen[i+1];
      namen[i+1]:=puffer;
      sortiert:=false;
     end;
   until (i>= anzahl-1-ende);

   inc(ende);
 until sortiert=true;
end;}

procedure Quicksort(var a: T_highscores;{variable die sortiert werden soll} iAnfang, iEnde: integer);
  var Anfang, Ende   : integer;
      Pivot, T   : T_highscore; {ein einzelnes Element der variablen zum auslagern}
  begin { von Quicksort }
    Anfang := iAnfang;
    Ende := iEnde;
    Pivot := A[(Anfang + Ende) div 2];
    repeat
      while A[Anfang].punkte > Pivot.punkte do Inc(Anfang); {Angabe wonach sortiert werden soll und wierum}
      while A[Ende].punkte < Pivot.punkte do Dec(Ende);     {Angabe wonach sortiert werden soll und wierum}
      if Anfang <= Ende then begin
        T:= A[Anfang];
        A[Anfang]:= A[Ende];
        A[Ende]:= T;
        Inc(Anfang);
        Dec(Ende);
      end;
    until Anfang > Ende;
    if Ende > iAnfang then Quicksort(A, iAnfang, Ende);
    if Anfang < iEnde then Quicksort(A, Anfang, iEnde);
  end; { von QuickSort}

PROCEDURE Bewegung;
VAR I, schwer : INTEGER;
BEGIN
 {---KI----}
  IF NOT Stop THEN BEGIN
    FOR I := 1 TO 4 DO
    IF (GetObject(I) AS TImage).Visible THEN BEGIN
      //if (GetObject(I) AS TImage).left < mainform.Cursor then showmessage('hallo');
      IF ((GetObject(I) AS TImage).left < (MainForm.bonnimage1.left+{50}(Mainform.bonnimage1.width div 2))) then (GetObject(I) AS TImage).left:=(GetObject(I) AS TImage).Left+5;
      IF ((GetObject(I) AS TImage).top < (MainForm.bonnimage1.top+{50}(Mainform.bonnimage1.height div 2))) then (GetObject(I) AS TImage).top:=(GetObject(I) AS TImage).Top+5;
    END;
    IF Ende THEN BEGIN
      Stop:=true;
      PlaySound2(SLost);
      Mainform.Schusstimer.enabled:=false;
      Mainform.schussimage.visible:=false;
      ShowMessage('Tja, '+titel+' hat doch '+zielort+' erreicht, du hast VERLOREN!');
      if (punkte*schwierigkeitsgrad) >= highscore[10].punkte then
      begin
       case schwierigkeitsgrad of  { Bewertung der einzelnen schwierigkeitsgrade}
       1 : highscore[10].punkte:=punkte;
       2 : highscore[10].punkte:=punkte+(punkte div 8);
       3 : highscore[10].punkte:=punkte+(punkte div 4);
       4 : highscore[10].punkte:=punkte+(punkte div 2);
       5 : highscore[10].punkte:=punkte+(punkte div 1);{schwer :=3;}
       end;
       {highscore[10].punkte:=punkte*schwer;}
       highscore[10].name:=spielername;
       highscore[10].schwierigkeitsgrad:=schwierigkeitsgrad;
      end;
     {bubblesort(highscore,10);}
      Quicksort(highscore,1,10);
      editorform.start;
      editorform.speichern(dateiaktuell);
      Mainform.dateischreiben(dateiaktuell);
      zumMenue;
    END;
  END;
end;

Procedure Punkt;
var schwer : integer;
begin
 inc(treffer);
 inc(punkte);
 MainForm.punktelabel5.caption:=inttostr(punkte);
 if (treffer*schwierigkeitsgrad) < 98 then schwer:=treffer*schwierigkeitsgrad else schwer:=98;
 MainForm.KiTimer1.Interval:= 100-schwer;
 if bild < 4 then
 begin
  if (treffer < 21) and ((treffer mod 5)=0) then
  begin
   inc(bild);
//  (MainForm.Components[bild + 3] AS TImage).visible:=true;
   (getobject(bild) as TImage).visible:=true;
  end;
 end;
end;

procedure Programmstart;
var i : integer;
begin

 erstemal:=true;
 With MainForm do begin
  Panel1.align:=alclient;
  soundanzahl:=15;
  SetLength(SoundFile,15);
  schwierigkeitsgrad:=1;

  dateilesen('standard');

  bild:=0;

  Label2.caption:=titel;
  panel2.width:=label2.width+20;
  startspeedbutton1.caption:=startbutton;

  for i:=1 to 10 do
  begin
   if highscore[i].name='' then
   begin
    highscore[i].name:='MD-Technologie';
    highscore[i].punkte:=1;
    highscore[i].schwierigkeitsgrad:=1;
   end;
  end;
  punkte:=0;
  sieg:=0;
  schaden:=10;
 end;
end;

{---------------Ende eigener Proceduren-------------}

procedure TMainForm.FormResize(Sender: TObject);
begin
 zentriert;
 BonnImage1.left:=width-BonnImage1.width-20;
 BonnImage1.top:=height-BonnImage1.height-50;
 ziellabel.left:=width-ziellabel.width-40;
 ziellabel.top:=height-ziellabel.height-30;
 label4.top:=1;
 label4.left:=(width div 2)-(label4.width div 2)-20;
 PunkteLabel5.top:=1;
 Punktelabel5.left:=label4.left+43;
 abschuss2image.top:=25;
 abschuss2image.left:=100;
 abschuss2label.left:=(abschuss2image.left+(abschuss2image.width div 2))-(abschuss2label.width div 2);
 abschuss2label.top:=Abschuss2Image.top+abschuss2image.height + energiegauge.height + 10;
 energieGauge.top:=Abschuss2Image.top+abschuss2image.height + 5;
 energieGauge.left:=(abschuss2image.left+(abschuss2image.width div 2))-(energiegauge.width div 2);
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
zentriert;
 { Panel1.align:=alclient;

 SetLength(SoundFile,12);
 SoundFile[0] := ExtractFileDir(Application.EXEName) + '\sound\au.wav';
 SoundFile[11] := ExtractFileDir(Application.EXEName) + '\sound\verloren.wav';
 for i:= 0 to 9 do
  begin
   Soundfile[i]:=ExtractFileDir(Application.EXEName) + '\sound\au' + inttostr(i+1) + '.wav';
  end;

 Image1.Picture.LoadFromFile(extractFileDir(Application.EXEName)+ '\bilder\abschuss.bmp');
 BonnImage1.Picture.LoadFromFile(extractFileDir(Application.EXEName)+ '\bilder\ziel.bmp');

 Panel3.caption:=titel;
 ZielLabel.caption:=zielort;

 bild:=0;
 dateineu;
 dateilesen;}
end;

procedure TMainForm.StartSpeedButton1Click(Sender: TObject);
begin
 start;
 standort;
end;

procedure TMainForm.EndeSpeedButton2Click(Sender: TObject);
begin
close;
end;

procedure TMainForm.optionenSpeedButton3Click(Sender: TObject);
begin
Optionenform.visible:=true;
Mainform.visible:=false;
end;

procedure TMainForm.HilfeSpeedButton4Click(Sender: TObject);
begin
  Hilfeform.visible:=true;
  Mainform.visible:=false;
end;

procedure TMainForm.KiTimer1Timer(Sender: TObject);
begin
  Bewegung;
end;

procedure TMainForm.Image1Click(Sender: TObject);
// var abspielen : integer;
begin
  ImageActive[(Sender AS TImage).ComponentIndex-3] := TRUE;
  (Sender AS TImage).Visible := False;
  Standort;
  Punkt;
  Randomize;
  PlaySound(random(soundanzahl));
end;

procedure TMainForm.Ende1Click(Sender: TObject);
begin
  Close;
end;

procedure TMainForm.EditorSpeedButtonClick(Sender: TObject);
begin
 EditorForm.visible:=true;
 MainForm.visible:=false;

end;

procedure TMainForm.FormKeyPress(Sender: TObject; var Key: Char);
begin
if key=#27 then close;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
 Programmstart;
end;

procedure TMainForm.Abschuss2ImageClick(Sender: TObject);
begin
if not schussImage.visible then
  begin
   Schussimage.visible:=true;
   Schussimage.top:=Bonnimage1.top+(Bonnimage1.height div 2);
   Schussimage.left:=Bonnimage1.left+(Bonnimage1.width div 2);
   Schusstimer.enabled:=true;
   playsound2(SSchuss);
  end;
end;

procedure TMainForm.SchussTimerTimer(Sender: TObject);
var schwer : integer;
begin
 if schussimage.left > abschuss2image.left + (abschuss2image.width div 2) then schussimage.left:=schussimage.left-7;
 if schussimage.top > abschuss2image.top then schussimage.top:=schussimage.top-5;

 if (schussimage.left in [abschuss2image.left..Abschuss2Image.left + abschuss2image.width-10])
    and (schussimage.top in [abschuss2image.top..Abschuss2Image.top + abschuss2image.height-10])
    then
     begin
      schusstimer.enabled:=false;
      schussimage.visible:=false;
      inc(punkte,6-schwierigkeitsgrad);
      inc(sieg);
      playsound2(Sexpl);
      punktelabel5.caption:=inttostr(punkte);
      energiegauge.progress:=energiegauge.progress-1;
      if energiegauge.progress >= ((energiegauge.MaxValue div 3)*2)
       then energiegauge.forecolor:=cllime
       else
        if energiegauge.progress >= (energiegauge.MaxValue div 3) then
         energiegauge.forecolor:=clyellow
         else energiegauge.forecolor:=clred;
     end;

 if sieg = schaden then
 begin
  inc(punkte,10);
  Stop:=true;
//  explosion;
  PlaySound2(SWin);
  ShowMessage('Sieg');
  if (punkte*schwierigkeitsgrad) >= highscore[10].punkte then
  begin
   case schwierigkeitsgrad of
    1 : schwer :=1;
    2 : schwer :=1;
    3 : schwer :=2;
    4 : schwer :=2;
    5 : schwer :=3;
   end;
   highscore[10].punkte:=punkte*schwer;
   highscore[10].name:=spielername;
   highscore[10].schwierigkeitsgrad:=schwierigkeitsgrad;
  end;
  Quicksort(highscore,1,10);
  Editorform.start;
  Editorform.speichern(dateiaktuell);
  Mainform.dateischreiben(dateiaktuell);
  zumMenue;
 end;

end;

procedure TMainForm.weiter1Click(Sender: TObject);
begin
 Mainform.KiTimer1.enabled:=true;
end;

procedure TMainForm.MenueClick(Sender: TObject);
begin
 zumMenue;
end;

procedure TMainForm.ExtraSpeedButtonClick(Sender: TObject);
begin
 Extrasform.visible:=true;
 Mainform.visible:=false;
end;

procedure TMainForm.Label7Click(Sender: TObject);
begin
 Hilfeform.executefile('http://www.md-technologie.de','','',1);
end;

procedure TMainForm.Label7MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 label7.cursor:=crhandpoint;
 label7.font.style:=[fsItalic];
 label7.font.color:=clnavy;
end;

procedure TMainForm.Panel1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 label7.cursor:=crdefault;
 label7.font.style:=[];
 label7.font.color:=clActiveCaption;
end;

end.

