unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, ComCtrls, ExtDlgs, MPlayer, Buttons;

type
  TEditorForm = class(TForm)
    SpeicherButton: TButton;
    AbbrechenButton4: TButton;
    OpenDialog1: TOpenDialog;
    ColorDialog1: TColorDialog;
    Button1: TButton;
    Speichernunterbutton: TButton;
    Button3: TButton;
    Button4: TButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    GroupBox2: TGroupBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpielnameEdit: TEdit;
    ZielnameEdit: TEdit;
    ZielCheckBox: TCheckBox;
    Abschuss2Edit: TEdit;
    Abschuss2CheckBox: TCheckBox;
    GroupBox1: TGroupBox;
    AbschussImage: TImage;
    ZielImage: TImage;
    Label4: TLabel;
    Label5: TLabel;
    AbschussButton: TButton;
    ZielButton: TButton;
    abschusstranspCheckBox: TCheckBox;
    zieltranspCheckBox: TCheckBox;
    Panel1: TPanel;
    schussImage: TImage;
    abschuss2Image: TImage;
    Label6: TLabel;
    Label7: TLabel;
    SchussButton: TButton;
    schusstranspCheckBox: TCheckBox;
    abschuss2Button: TButton;
    abschuss2transpCheckBox: TCheckBox;
    anausCheckBox: TCheckBox;
    TabSheet3: TTabSheet;
    GroupBox3: TGroupBox;
    neusoundedit: TEdit;
    Hinzu: TButton;
    loeschen: TButton;
    Durchsuchen1: TButton;
    ListBox1: TListBox;
    GroupBox4: TGroupBox;
    verlorensoundEdit: TEdit;
    siegsoundEdit: TEdit;
    explosionssoundEdit: TEdit;
    schussstartsoundEdit: TEdit;
    Durchsuchen2: TButton;
    Durchsuchen3: TButton;
    Durchsuchen4: TButton;
    Durchsuchen5: TButton;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label8: TLabel;
    OpenPictureDialog1: TOpenPictureDialog;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    GroupBox5: TGroupBox;
    HFarbeButton: TButton;
    Shape1: TShape;
    hbildButton: TButton;
    hbildEdit: TEdit;
    Label16: TLabel;
    hbildCheckBox1: TCheckBox;
    HbildImage: TImage;
    Label17: TLabel;
    GroupBox6: TGroupBox;
    Label18: TLabel;
    GroupBox7: TGroupBox;
    startbuttonEdit: TEdit;
    Label19: TLabel;
    Memo1: TMemo;
    Label20: TLabel;
    GroupBox8: TGroupBox;
    BitBtn1: TBitBtn;
    BitBtn2: TBitBtn;
    BitBtn3: TBitBtn;
    BitBtn4: TBitBtn;
    BitBtn5: TBitBtn;
    BitBtn6: TBitBtn;
    SoundTrackBar: TTrackBar;
    SoundTimer: TTimer;
    MediaPlayer1: TMediaPlayer;
    TextfarbeButton: TButton;
    Label21: TLabel;
    procedure ZielCheckBoxClick(Sender: TObject);
    procedure AbbrechenButton4Click(Sender: TObject);
    procedure Abschuss2CheckBoxClick(Sender: TObject);
    procedure SpeicherButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure HFarbeButtonClick(Sender: TObject);
    procedure AbschussButtonClick(Sender: TObject);
    procedure ZielButtonClick(Sender: TObject);
    procedure abschusstranspCheckBoxClick(Sender: TObject);
    procedure zieltranspCheckBoxClick(Sender: TObject);
    procedure anausCheckBoxClick(Sender: TObject);
    procedure schusstranspCheckBoxClick(Sender: TObject);
    procedure abschuss2transpCheckBoxClick(Sender: TObject);
    procedure SchussButtonClick(Sender: TObject);
    procedure abschuss2ButtonClick(Sender: TObject);
    procedure Durchsuchen1Click(Sender: TObject);
    procedure HinzuClick(Sender: TObject);
    procedure loeschenClick(Sender: TObject);
    procedure Durchsuchen2Click(Sender: TObject);
    procedure Durchsuchen3Click(Sender: TObject);
    procedure Durchsuchen4Click(Sender: TObject);
    procedure Durchsuchen5Click(Sender: TObject);
    procedure hbildButtonClick(Sender: TObject);
    procedure hbildCheckBox1Click(Sender: TObject);
    procedure SpeichernunterbuttonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure speichern(name: string);
    procedure start;
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure BitBtn3Click(Sender: TObject);
    procedure BitBtn4Click(Sender: TObject);
    procedure BitBtn5Click(Sender: TObject);
    procedure BitBtn6Click(Sender: TObject);
    procedure SoundTimerTimer(Sender: TObject);
    procedure TextfarbeButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  EditorForm: TEditorForm;

implementation

uses GamecreatorUnit1, speicherUnit2,FileCtrl, LadenUnit2;


TYPE
   T_zeiger = ^T_sound;
   T_sound= RECORD
               Pfad  : string;
               name  : string; {nur der Dateiname}
               zeiger: T_zeiger;
             END;


CONST
      bilderordner  = 'bilder';
      soundordner   = 'sound';

 var
  auswahlabschuss, auswahlziel, auswahlanaus,
  auswahlschuss, auswahlabschuss2    :string;
  usesound                           :T_zeiger;

{$R *.DFM}

{-------------eigene Proceduren--------------}

Function Verzeichnis(pfad: string): string;
{liest aus einer kompletten Dateiangabe nur den Dateinamen aus}
var  stelle    : integer;
begin
 stelle:=1;
 repeat
  stelle:=pos('\',pfad)+1;
  pfad:=copy(pfad,stelle,length(pfad));
 until stelle=1;
 verzeichnis:=pfad;
end;

function kopieren(auswahl,ordner: string) : string;
{kopiert das Bild/Sounddatei in das Verzeichnis Bilder/Sound vom Gamecreator}
 var ausgabe : string;

     i       : longbool;
     position: integer;
begin

   ausgabe:=auswahl;
   while pos('\',ausgabe) > 0 do
    begin
     position:=pos('\',ausgabe);
     ausgabe:=copy(ausgabe,position+1,length(ausgabe));
    end;

    if not DirectoryExists(extractFileDir(Application.EXEName)+'\'+dateiaktuell) then
     begin
      ChDir(extractFileDir(Application.EXEName));{wechselt in das erstellte Verzeichnis}
      CreateDir(dateiaktuell);                   {erstellt Verzeichnis mit abgefragtem Namen}
      ChDir(extractFileDir(Application.EXEName)+'\'+dateiaktuell);{wechselt in das erstellte Verzeichnis}
      CreateDir('bilder');                        {erstellt in diesem Ordner den Unterordner bilder}
      CreateDir('sound');                         {das gleiche mit "sound"}
      ChDir(extractFileDir(Application.EXEName)); {wechselt zurck in den Hauptordner}
     end;

   ausgabe:=extractFileDir(Application.EXEName)+'\'+dateiaktuell+'\'+ordner+'\'+ausgabe;
   if not (auswahl= ausgabe) then
    begin
      //if FileExists(ausgabe) then showmessage(auswahl+' '+ausgabe);
      if FileExists(ausgabe) then deletefile(ausgabe);
      copyfile(Pchar(auswahl),Pchar(ausgabe),i);
    end;
   //if auswahl= ausgabe then Showmessage('Datei existiert schon.');
   kopieren:=ausgabe;
end;

procedure eintraegeneu;
 var use : t_zeiger;
begin
  use:=usesound;
  Editorform.listbox1.clear;
  while use<>nil do   {schreibt alle Eintrge neu, den zeigern folgend}
  begin
   Editorform.listbox1.items.Add(use^.name);
   use:=use^.zeiger;
  end;
end;

procedure soundeinlesen;
var i : integer;
    neu : T_zeiger;
begin
 //SetLength(Sounds,soundanzahl2);
 usesound:=nil;
 for i:= 0 to soundanzahl-1 do
  begin
   new(neu);
   neu^.Pfad:=soundfile[i];
   neu^.name:=Verzeichnis(SoundFile[i]);
   neu^.zeiger:=usesound;
   usesound:=neu;
   //editorform.ListBox1.Items.add(neu^.name);
  end;
 eintraegeneu;
end;

procedure TEditorForm.speichern(name: string);
var i  : integer;
    tempzeiger: T_Zeiger;

 procedure bildinarray(info : string);
 begin
  inc(i);
  if info <> '' then bilder[i]:=info;
 end;

 procedure beschrinarray(info : string);
 begin
  inc(i);
  if info <> '' then beschriftung[i]:=info;
 end;

 procedure sonstigesinarray(info : string);
 begin
  inc(i);
  if info <> '' then sonstiges[i]:=info+'false';
 end;

begin
with Editorform do
 begin
 i:=1;
  while not (bilder[i]='') do
  begin
   bilder[i]:='';
   inc(i);
  end;
 i:=1;
  while not (beschriftung[i]='') do
  begin
   beschriftung[i]:='';
   inc(i);
  end;
 i:=1;
  while not (sonstiges[i]='') do
  begin
   sonstiges[i]:='';
   inc(i);
  end;
 { macht alle Arrays leer }

  if not (auswahlabschuss='') then abschuss:=auswahlabschuss;
  if not (auswahlziel='')     then ziel:=auswahlziel;
  if not (auswahlschuss='')   then schuss:=auswahlschuss;
  if not (auswahlabschuss2='')then abschuss2:=auswahlabschuss2;
  if not (auswahlanaus='')    then anaus:=auswahlanaus;

  if (hbildcheckbox1.Checked) and (hbildedit.text<>'') then hbild:=hbildedit.text
   else hbildcheckbox1.checked:=false;

  abschuss:=kopieren(abschuss,bilderordner);
  ziel:=kopieren(ziel,bilderordner);
  schuss:=kopieren(schuss,bilderordner);
  abschuss2:=kopieren(abschuss2,bilderordner);
  if not hbildcheckbox1.checked then hbild:='' else
   hbild:=kopieren(hbild,bilderordner);

  {kopiert die Bilder in den Gamecreatorordner}



  titel:=Spielnameedit.text;
  zielort:=Zielnameedit.text;
  abschuss2ort:=abschuss2edit.text;
  startbutton:=startbuttonedit.text;
  i:=0;

  str(shape1.Brush.color,hfarbe);
  str(Label21.font.color,textfarbe);

  bildinarray('Ziel: '+ziel);
  bildinarray('Abschuss: '+abschuss);
  bildinarray('Hintergrundfarbe: '+hfarbe);
  bildinarray('Textfarbe: '+textfarbe);
  bildinarray('Abschuss2: '+abschuss2);
  bildinarray('Schuss: '+schuss);
  if hbildcheckbox1.checked then
   bildinarray('Hintergrundbild: '+hbild);
  i:=0;
  beschrinarray('Titel: '+titel);
  beschrinarray('Zielort: '+zielort);
  beschrinarray('Abschuss2ort: '+abschuss2ort);
  beschrinarray('Startbutton: '+startbutton);

  soundanzahl:=0;
  tempzeiger:=usesound;
  While tempzeiger<>nil do {zhlt die Anzahl der Sounds weil SetLenght vor der Zuweisung gesetzt werden muss}
  begin
   inc(soundanzahl);
   tempzeiger:=tempzeiger.zeiger;
  end;

  SetLength(SoundFile,soundanzahl);

  tempzeiger:=usesound;
 i:=0;
  While tempzeiger <> nil do  {bergibt die Soundangaben in den array und kopiert die soundfiles in den Gamecreatorordner}
  begin
   tempzeiger.pfad:=kopieren(tempzeiger.pfad,soundordner);
   SoundFile[i]:=tempzeiger.pfad;
   tempzeiger:=tempzeiger.zeiger;
   inc(i);
  end;

  spezialsoundfile[1]:=verlorensoundedit.text;
  spezialsoundfile[2]:=siegsoundedit.text;
  spezialsoundfile[3]:=explosionssoundedit.text;
  spezialsoundfile[4]:=schussstartsoundedit.text;
  spezialsoundfile[1]:=kopieren(spezialsoundfile[1],soundordner);
  spezialsoundfile[2]:=kopieren(spezialsoundfile[2],soundordner);
  spezialsoundfile[3]:=kopieren(spezialsoundfile[3],soundordner);
  spezialsoundfile[4]:=kopieren(spezialsoundfile[4],soundordner);

  i:=0;
  if not zielcheckbox.checked then sonstigesinarray('Zieltext sichtbar: ') else zielsichtbar:='';
  if not abschuss2checkbox.checked then sonstigesinarray('Abschuss2text sichtbar: ') else abschuss2sichtbar:='';
  if not abschusstranspcheckbox.checked then sonstigesinarray('Abschuss Transparent: ') else abschusstransp:='';
  if not zieltranspcheckbox.checked then sonstigesinarray('Ziel Transparent: ') else zieltransp:='';
  {checkbox checked=true ist standard, brauch nicht in die Setupdatei eingetragen werden}
  if not anauscheckbox.checked then sonstigesinarray('Ab2 aktiv: ') else anaus:='';
  if not schusstranspcheckbox.Checked then sonstigesinarray('Schuss Transparent: ') else schusstransp:='';
  if not abschuss2transpcheckbox.Checked then sonstigesinarray('Abschuss2 Transparent: ') else abschuss2transp:='';
  if not hbildcheckbox1.checked then sonstigesinarray('Hintergrundbild aktiviert: ') else hbildanaus:='';


  With Mainform do
  begin
   Label2.caption:=titel;
   panel2.width:=label2.width+20;
   startspeedbutton1.caption:=startbutton;
    ZielLabel.caption:=zielort;
 //  Image1.Picture.LoadFromFile(extractFileDir(Application.EXEName)+ '\bilder\abschuss.bmp');
 //  BonnImage1.Picture.LoadFromFile(extractFileDir(Application.EXEName)+ '\bilder\ziel.bmp');
  end;

    mediaplayer1.close;
    Listbox1.items.clear;
 end;
  Memo1.lines.SaveToFile(extractfiledir(Application.EXEName)+'\'+name+'\hilfe.txt');
  Mainform.dateischreiben(name);{!}
  Mainform.dateiexlesen(name);
  MainForm.visible:=true;
  visible:=false;
end;

procedure TEditorForm.start;
var i : integer;
begin
with editorform do
begin
 Spielnameedit.text:=titel;
 Zielnameedit.text:=zielort;
 abschuss2edit.text:=abschuss2ort;
 Abschussimage.picture.LoadFromFile(abschuss);
 Memo1.lines.LoadFromFile(extractfiledir(Application.EXEName)+'\'+dateiaktuell+'\hilfe.txt');
 startbuttonedit.text:=startbutton;

 Zielimage.picture.LoadFromFile(ziel);
 schussimage.picture.loadfromfile(schuss);
 abschuss2image.picture.loadfromfile(abschuss2);
 if zielsichtbar='false' then zielcheckbox.checked:=false else zielcheckbox.checked:=true;
 if abschuss2sichtbar='false' then abschuss2checkbox.checked:=false else abschuss2checkbox.checked:=true;
 if abschusstransp='false' then abschusstranspcheckbox.checked:=false else abschusstranspcheckbox.checked:=true;
 if zieltransp='false' then zieltranspcheckbox.checked:=false else zieltranspcheckbox.checked:=true;
 if anaus='false' then anauscheckbox.checked:=false else anauscheckbox.checked:=true;
 if schusstransp='false' then schusstranspcheckbox.checked:=false else schusstranspcheckbox.checked:=true;
 if abschuss2transp='false' then abschuss2transpcheckbox.checked:=false else abschuss2transpcheckbox.checked:=true;

 if hbildanaus='false' then hbildcheckbox1.checked:=false else hbildcheckbox1.checked:=true;
  shape1.Brush.color:=strtoint(hfarbe);
  Label21.font.color:=strtoint(textfarbe);
 if hbildcheckbox1.checked then hbildedit.text:=hbild;
 label12.caption:='Bildgre: '+inttostr(Abschussimage.width)+'*'+inttostr(abschussimage.height)+' Pixel';
 label13.caption:='Bildgre: '+inttostr(Zielimage.width)+'*'+inttostr(Zielimage.height)+' Pixel';
 label14.caption:='Bildgre: '+inttostr(schussimage.width)+'*'+inttostr(schussimage.height)+' Pixel';
 label15.caption:='Bildgre: '+inttostr(Abschuss2image.width)+'*'+inttostr(abschuss2image.height)+' Pixel';
 if not (hbildanaus='false') then
 begin
  hbildimage.picture.LoadFromFile(hbild);
  label16.caption:='Bildgre: '+inttostr(hbildimage.width)+'*'+inttostr(hbildimage.height);
 end
 else label16.caption:='Bildgre: ';
 label17.caption:='Bildschirm: '+inttostr(screen.width)+'*'+inttostr(screen.height);

 label18.caption:=dateiaktuell;
 groupbox8.caption:='Sound abspielen: ';
 pagecontrol1.activepageindex:=1;
 soundeinlesen;
 verlorensoundedit.text:=spezialsoundfile[1];
 siegsoundedit.text:=spezialsoundfile[2];
 explosionssoundedit.text:=spezialsoundfile[3];
 schussstartsoundedit.text:=spezialsoundfile[4];

 for i:=77 to 80 do (Editorform.components[i] as Tbitbtn).glyph:=bitbtn1.Glyph;

 end;
end;

{Zeiger (pointersimulation) nachgeahmt}
 procedure suchevornach( VAR vorgaenger,nachfolger: t_zeiger; inhalt: string );
 var gefunden : boolean;
 begin
 gefunden:=false;
 While (nachfolger<>nil) and not gefunden do
  if nachfolger^.name <> inhalt then
   begin
    vorgaenger := nachfolger;
    nachfolger :=nachfolger^.zeiger;
   end
   else gefunden:=true;
 end;

procedure musikabspielen;
begin
 with editorform do
 begin
  MediaPlayer1.Open;
  editorform.MediaPlayer1.Open;
  soundtimer.enabled:=true;
  soundtrackbar.max:=mediaplayer1.length;
  mediaplayer1.play;
 end;
end;
{--------------Ende eigener Proceduren------------}

procedure TEditorForm.ZielCheckBoxClick(Sender: TObject);
begin
If ZielCheckbox.checked then
   ZielCheckbox.caption:='sichtbar'
   else ZielCheckbox.caption:='nicht sichtbar ';
end;

procedure TEditorForm.AbbrechenButton4Click(Sender: TObject);
begin
 mediaplayer1.close;

 With Editorform do
  begin
   Listbox1.items.clear;
  end;

 With Mainform do
 begin
  Label2.caption:=titel;
  panel2.width:=label2.width+20;
  startspeedbutton1.caption:=startbutton;
  ZielLabel.caption:=zielort;
 end;

 MainForm.visible:=true;
 EditorForm.visible:=false;
end;

procedure TEditorForm.Abschuss2CheckBoxClick(Sender: TObject);
begin
If Abschuss2Checkbox.checked then
   Abschuss2Checkbox.caption:='sichtbar'
   else Abschuss2Checkbox.caption:='nicht sichtbar ';
end;

procedure TEditorForm.SpeicherButtonClick(Sender: TObject);
begin
 speichern(dateiaktuell);
end;

procedure TEditorForm.FormShow(Sender: TObject);
begin
 start;
end;

procedure TEditorForm.HFarbeButtonClick(Sender: TObject);
begin
 if colordialog1.Execute then Shape1.Brush.color:=ColorDialog1.Color;
end;

procedure TEditorForm.AbschussButtonClick(Sender: TObject);
 var  test : string;
begin
if openpicturedialog1.Execute then auswahlabschuss:=Openpicturedialog1.FileName;
if auswahlabschuss <> '' then
 begin
  Abschussimage.picture.LoadFromFile(auswahlabschuss);
  label12.caption:='Bildgre: '+inttostr(Abschussimage.width)+'*'+inttostr(abschussimage.height)+' Pixel';
  test:=copy(auswahlabschuss,length(auswahlabschuss)-2,99);
  if (test='jpg') or (test='JPG') or (test='peg') then { peg bei jpeg}
   begin
    abschusstranspcheckbox.checked:=true;
    abschusstranspcheckbox.enabled:=false;
   end
   else
    begin
     abschusstranspcheckbox.checked:=true;
     abschusstranspcheckbox.enabled:=true;
    end;
  end
 else
  begin
   showmessage('Sie haben keine neue Datei ausgewhlt.');
  end;
{ if (Abschussimage.width > 25) or (Abschussimage.height > 25) or
    (Abschussimage.width < 25) or (Abschussimage.height < 25) then
 Showmessage('Die optimale gre fr das Abschussobjekt ist 25*25 Pixel. Aktuell ist es '+inttostr(Abschussimage.width)+'*'+inttostr(Abschussimage.width)+' Pixel.');}
end;

procedure TEditorForm.ZielButtonClick(Sender: TObject);
 var  test : string;
begin
if openpicturedialog1.Execute then auswahlziel:=Openpicturedialog1.FileName;
if auswahlziel <> '' then
 begin
  zielimage.picture.LoadFromFile(auswahlziel);
  label13.caption:='Bildgre: '+inttostr(Zielimage.width)+'*'+inttostr(Zielimage.height)+' Pixel';
  test:=copy(auswahlziel,length(auswahlziel)-2,99);
  if (test='jpg') or (test='JPG') or (test='peg') then { peg bei jpeg}
   begin
    zieltranspcheckbox.checked:=true;
    zieltranspcheckbox.enabled:=false;
   end
   else
    begin
     zieltranspcheckbox.checked:=true;
     zieltranspcheckbox.enabled:=true;
    end;
 end
 else
  begin
   showmessage('Sie haben keine neue Datei ausgewhlt.');
  end;
 {if (zielimage.width > 100) or (zielimage.height > 100) or
    (zielimage.width < 100) or (zielimage.height < 100) then
 Showmessage('Die optimale gre fr das Abschussobjekt ist 100*100 Pixel. Aktuell ist es '+inttostr(zielimage.width)+'*'+inttostr(zielimage.width)+' Pixel.');}
end;

procedure TEditorForm.abschusstranspCheckBoxClick(Sender: TObject);
begin
If abschusstranspCheckbox.checked then
   begin
    abschusstranspCheckbox.caption:='Transparenz an';
    abschussimage.transparent:=true;
   end
   else
   begin
    abschusstranspCheckbox.caption:='Transparenz aus';
    abschussimage.transparent:=false;
   end; 
end;

procedure TEditorForm.zieltranspCheckBoxClick(Sender: TObject);
begin
If ZieltranspCheckbox.checked then
   begin
    ZieltranspCheckbox.caption:='Transparenz an';
    zielimage.transparent:=true
   end
   else
   begin
    ZieltranspCheckbox.caption:='Transparenz aus';
    zielimage.transparent:=false;
   end;

end;

procedure TEditorForm.anausCheckBoxClick(Sender: TObject);
begin
 if anauscheckbox.Checked then
  begin
   anauscheckbox.caption:='Abschussobjekt 2 aktiviert';
   panel1.Enabled:=true;
   schussbutton.enabled:=true;
   abschuss2button.Enabled:=true;
   schusstranspcheckbox.Enabled:=true;
   abschuss2transpcheckbox.enabled:=true;
   label6.enabled:=true;
   label7.enabled:=true;
   label14.enabled:=true;
   label15.enabled:=true;
   schussimage.enabled:=true;
   abschuss2image.enabled:=true;
   auswahlanaus:='true';
  end
  else
   begin
    anauscheckbox.caption:='Abschussobjekt 2 deaktiviert';
    panel1.Enabled:=false;
    schussbutton.enabled:=false;
    abschuss2button.Enabled:=false;
    schusstranspcheckbox.Enabled:=false;
    abschuss2transpcheckbox.enabled:=false;
    label6.enabled:=false;
    label7.enabled:=false;
    label14.enabled:=false;
    label15.enabled:=false;
    schussimage.enabled:=false;
    abschuss2image.enabled:=false;
    auswahlanaus:='false';
   end;
end;

procedure TEditorForm.schusstranspCheckBoxClick(Sender: TObject);
begin
If schusstranspCheckbox.checked then
   begin
    schusstranspCheckbox.caption:='Transparenz an';
    schussimage.transparent:=true
   end
   else
   begin
    schusstranspCheckbox.caption:='Transparenz aus';
    schussimage.transparent:=false;
   end;

end;

procedure TEditorForm.abschuss2transpCheckBoxClick(Sender: TObject);
begin
If abschuss2transpCheckbox.checked then
   begin
    abschuss2transpCheckbox.caption:='Transparenz an';
    abschuss2image.transparent:=true
   end
   else
   begin
    abschuss2transpCheckbox.caption:='Transparenz aus';
    abschuss2image.transparent:=false;
   end;

end;

procedure TEditorForm.SchussButtonClick(Sender: TObject);
 var test : string;
begin
if openpicturedialog1.Execute then auswahlschuss:=Openpicturedialog1.FileName;
if auswahlschuss <> '' then
 begin
  schussimage.picture.LoadFromFile(auswahlschuss);
  label14.caption:='Bildgre: '+inttostr(schussimage.width)+'*'+inttostr(schussimage.height)+' Pixel';
  test:=copy(auswahlschuss,length(auswahlschuss)-2,99);
  if (test='jpg') or (test='JPG') or (test='peg') then { peg bei jpeg}
   begin
    schusstranspcheckbox.checked:=true;
    schusstranspcheckbox.enabled:=false;
   end
   else
    begin
     schusstranspcheckbox.checked:=true;
     schusstranspcheckbox.enabled:=true;
    end;
 end
 else
  begin
   showmessage('Sie haben keine neue Datei ausgewhlt.');
  end;
end;

procedure TEditorForm.abschuss2ButtonClick(Sender: TObject);
 var test : string;
begin
if openpicturedialog1.Execute then auswahlabschuss2:=Openpicturedialog1.FileName;
if auswahlabschuss2 <> '' then
 begin
  abschuss2image.picture.LoadFromFile(auswahlabschuss2);
  label15.caption:='Bildgre: '+inttostr(Abschuss2image.width)+'*'+inttostr(abschuss2image.height)+' Pixel';
  test:=copy(auswahlabschuss2,length(auswahlabschuss2)-2,99);
  if (test='jpg') or (test='JPG') or (test='peg') then { peg bei jpeg}
   begin
    abschuss2transpcheckbox.checked:=true;
    abschuss2transpcheckbox.enabled:=false;
   end
   else
    begin
     abschuss2transpcheckbox.checked:=true;
     abschuss2transpcheckbox.enabled:=true;
    end;
 end
 else
  begin
   showmessage('Sie haben keine neue Datei ausgewhlt.');
  end;

end;

procedure TEditorForm.Durchsuchen1Click(Sender: TObject);
begin
 if opendialog1.Execute then neusoundedit.text:=Opendialog1.FileName;
end;

procedure TEditorForm.HinzuClick(Sender: TObject);
var  neu  : t_zeiger;
begin  {fgt neuen Eintrag hinzu. Neuer Eintrag ist erster Eintrag.}
if neusoundedit.text <> '' then
 begin
  new(neu);
  neu^.pfad:=neusoundedit.text;
  neu^.name:=Verzeichnis(neusoundedit.text);
  neu^.zeiger:=usesound;
  usesound:=neu;
  eintraegeneu;
 end;
end;

procedure TEditorForm.loeschenClick(Sender: TObject);
var  vor, nach, ende, temp : T_zeiger;
     anfang                : boolean;
     inhalt                : string;

begin
 vor:=nil;
 nach:=usesound;
 temp:=nach^.zeiger;

 if (listbox1.itemindex<>-1) and (temp<>nil) then { wenn etwas ausgewhlt ist und noch mindestens 2 Eintrge vorhanden sind,..}
 begin
  inhalt:=listbox1.items.strings[listbox1.ItemIndex];
  suchevornach(vor,nach,inhalt);
  if (nach <> nil) then
   begin
    if (inhalt=nach^.name) then
     begin
       if (vor=nil) then usesound:=nach^.zeiger
       else vor^.zeiger:=nach^.zeiger;
       dispose(nach)
     end else showmessage('Keinen Eintrag gefunden!');
   end else showmessage('Keinen Eintrag gefunden!');
 end else showmessage('Sie mssen einen Eintrag ausgewhlt haben und es muss immer ein Eintrag brig bleiben.');
 eintraegeneu;
end;

procedure TEditorForm.Durchsuchen2Click(Sender: TObject);
begin
 if opendialog1.Execute then
  if Opendialog1.FileName <> '' then verlorensoundedit.text:=Opendialog1.FileName;
end;

procedure TEditorForm.Durchsuchen3Click(Sender: TObject);
begin
 if opendialog1.Execute then
  if Opendialog1.FileName <> '' then siegsoundedit.text:=Opendialog1.FileName;
end;

procedure TEditorForm.Durchsuchen4Click(Sender: TObject);
begin
 if opendialog1.Execute then
  if Opendialog1.FileName <> '' then explosionssoundedit.text:=Opendialog1.FileName;
end;

procedure TEditorForm.Durchsuchen5Click(Sender: TObject);
begin
 if opendialog1.Execute then 
  if Opendialog1.FileName <> '' then schussstartsoundedit.text:=Opendialog1.FileName;
end;

procedure TEditorForm.hbildButtonClick(Sender: TObject);
var hoehe, breite :  integer;
begin
 if openpicturedialog1.Execute then
  if Openpicturedialog1.FileName <> '' then
  begin
   hbildimage.picture.LoadFromFile(Openpicturedialog1.FileName);
   breite:=hbildimage.width;
   hoehe:=hbildimage.height;
   if ((hoehe < 479) or (hoehe > screen.height))
   or ((breite < 639) or (breite > screen.width))
    then showmessage('Ihr ausgewhltes bild ist zu klein/gross ! Minimum: 640*480, Maximum: Ihre Bildschirmauflsung: '+inttostr(screen.width)+'*'+ inttostr(screen.height)+' !')
    else
    begin
     hbildedit.text:=Openpicturedialog1.FileName;
     label16.caption:='Bildgre: '+inttostr(breite)+'*'+inttostr(hoehe);
   end;
  end;
end;

procedure TEditorForm.hbildCheckBox1Click(Sender: TObject);
begin
 if hbildCheckbox1.Checked then
  begin
   hbildCheckbox1.caption:='Ein Hintergrundbild verwenden';
   hbildbutton.enabled:=true;
   hbildedit.enabled:=true;
   label16.enabled:=true;
   label17.enabled:=true;
  end
 else
  begin
   hbildCheckbox1.caption:='Kein Hintergrundbild verwenden';
   hbildbutton.enabled:=false;
   hbildedit.enabled:=false;
   label16.enabled:=false;
   label17.enabled:=false;
   hbildedit.text:='';
   label16.caption:='Bildgre:';
  end;
end;

procedure TEditorForm.SpeichernunterbuttonClick(Sender: TObject);
begin
 editorform.enabled:=false;
 Speichernform.visible:=true;
end;

procedure TEditorForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 mediaplayer1.close;
 Listbox1.items.clear;
 MainForm.visible:=true;
 EditorForm.visible:=false;
end;

procedure TEditorForm.Button3Click(Sender: TObject);

 procedure loeschedatei;
 var dateien   : TSearchRec;
     schleife  : integer;
     verz,verz2      : string;
 begin
  deletefile(extractFileDir(Application.EXEName)+'\'+dateiaktuell+'.cfg');
  deletefile(extractFileDir(Application.EXEName)+'\'+dateiaktuell+'\hilfe.txt');

  for schleife:=1 to 2 do
  begin
   if schleife=1 then verz:=extractFileDir(Application.EXEName)+'\'+dateiaktuell+'\bilder\*.*';
   if schleife=2 then verz:=extractFileDir(Application.EXEName)+'\'+dateiaktuell+'\sound\*.*';
   findfirst(verz,faAnyFile,dateien);

   while findnext(dateien)=0 do
    begin
      if dateien.attr <> faDirectory then
      deletefile(copy(verz,1,length(verz)-3)+dateien.name);  {kopiert *.* weg }
    end;
   findclose(dateien);
   removedir(copy(verz,1,length(verz)-3));
  end;
  removedir(extractFileDir(Application.EXEName)+'\'+dateiaktuell);
 end;

 PROCEDURE loeschedaten(inhalt: string);
 var nf, vg : T_Dzeiger;

 BEGIN
  Mainform.suchevornach(inhalt,vg,nf);
  if (nf <> nil) then
   begin
    if (inhalt=nf^.name) then
     begin
       if (vg=nil) then usedatei:=nf^.zeiger else vg^.zeiger:=nf^.zeiger;
          loeschedatei;
        dispose(nf);
          dateiaktuell:='standard';
          Mainform.dateischreibensetup;
          Mainform.dateiexlesen(dateiaktuell);
          Editorform.start;
     end else showmessage('Eintrag nicht gefunden!');
   end else showmessage('Eintrag nicht gefunden!');
 END;

begin
 if MessageDlg('Wollen Sie das aktuell Szenario wirklich lschen?',
    mtWarning, [mbYes, mbNo], 0) = mrYes then
     if not (uppercase(dateiaktuell)=uppercase('standard')) then
      begin
       showMessage('Folgendes Szenario wurde gelscht: '+dateiaktuell);
       loeschedaten(dateiaktuell);
      end
      else showmessage('Das Szenario "Standard" ist das Hauptszenario und kann nicht (!!) gelscht werden.');
end;

procedure TEditorForm.Button1Click(Sender: TObject);
begin
 editorform.visible:=false;
 Ladenform.visible:=true;
end;

procedure TEditorForm.Button4Click(Sender: TObject);
var i : integer;
    temp: string;

 procedure bildinarray(info : string);
 begin
  inc(i);
  if info <> '' then bilder[i]:=info;
 end;

 procedure beschrinarray(info : string);
 begin
  inc(i);
  if info <> '' then beschriftung[i]:=info;
 end;

begin
if MessageDlg('Wollen Sie alles auf den Standardwert zurcksetzen?',
  mtWarning, [mbYes, mbNo], 0) = mrYes then
 begin;
  ziel:=extractfiledir(application.exename)+'\Standard\bilder\ziel.bmp';
  abschuss:= extractfiledir(application.exename)+'\Standard\bilder\abschuss.bmp';
  abschuss2:= extractfiledir(application.exename)+'\Standard\bilder\abschuss2.bmp';
  schuss:= extractfiledir(application.exename)+'\Standard\bilder\schuss.bmp';
  hfarbe:= '0';
  textfarbe:= '12632256';
  hbild:=extractfiledir(application.exename)+'\Standard\bilder\hbild.jpg';

  titel:= 'Alien';
  zielort:= 'Erde';
  abschuss2ort:= 'Mutterschiff';
  startbutton:= 'Start';

   bildinarray('Ziel: '+ziel);
   bildinarray('Abschuss: '+abschuss);
   bildinarray('Hintergrundfarbe: '+hfarbe);
   bildinarray('Textfarbe: '+textfarbe);
   bildinarray('Abschuss2: '+abschuss2);
   bildinarray('Schuss: '+schuss);
   i:=0;
   beschrinarray('Titel: '+titel);
   beschrinarray('Zielort: '+zielort);
   beschrinarray('Abschuss2ort: '+abschuss2ort);
   beschrinarray('Startbutton: '+startbutton);


  spielername:= 'Spieler';
  temp:= 'MD-Technologie;110;1;MD-Technologie;12;1;MD-Technologie;10;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;MD-Technologie;1;1;';

   for i:=1 to 10 do
   begin
    highscore[i].name:=copy(temp,1,pos(';',temp)-1);
    temp:=copy(temp,pos(';',temp)+1,length(temp));
    highscore[i].punkte:=strtoint(copy(temp,1,pos(';',temp)-1));
    temp:=copy(temp,pos(';',temp)+1,length(temp));
    highscore[i].schwierigkeitsgrad:=strtoint(copy(temp,1,pos(';',temp)-1));
    temp:=copy(temp,pos(';',temp)+1,length(temp));
   end;


  Schwierigkeitsgrad:= 1;

  Soundanzahl:= 10;
  SetLength(SoundFile,10);
  for i:=0 to 9 do Soundfile[i]:=ExtractFileDir(Application.EXEName) + '\Standard\sound\au' + inttostr(i+1) + '.wav';

  spezialsoundfile[1]:= ExtractFileDir(Application.EXEName) + '\Standard\sound\verloren.wav';
  spezialsoundfile[1]:= ExtractFileDir(Application.EXEName) + '\Standard\sound\sieg.wav';
  spezialsoundfile[1]:= ExtractFileDir(Application.EXEName) + '\Standard\sound\explosion.wav';
  spezialsoundfile[1]:= ExtractFileDir(Application.EXEName) + '\Standard\sound\schussstart.wav';

  hbildanaus:= '';
  abschuss2sichtbar:='';
  zielsichtbar:='';
  abschusstransp:='';
  zieltransp:='';
  schusstransp:='';
  abschuss2transp:='';
  anaus:='';

  Mainform.dateischreiben(dateiaktuell);
  //Mainform.visible:=false;
  //Editorform.visible:=true;
  Editorform.start;
 end;
end;

procedure TEditorForm.BitBtn1Click(Sender: TObject);
var  vor, nach, ende       : T_zeiger;
     inhalt                : string;
begin
  if listbox1.itemindex<>-1 then { wenn etwas ausgewhlt ist,.. }
  begin
   vor:=nil;
   nach:=usesound;
   inhalt:=listbox1.items.strings[listbox1.ItemIndex];
   groupbox8.caption:='Sound abspielen: '+inhalt;
   suchevornach(vor,nach,inhalt);
   mediaplayer1.filename:=nach^.pfad;
   musikabspielen;
  end
  else showmessage('Zuerst muss eine Datei aus der "Neue Sounds"-Liste ausgewhlt werden');
end;

procedure TEditorForm.BitBtn2Click(Sender: TObject);
begin
 Mediaplayer1.Stop;
 soundtrackbar.position:=0;
 soundtimer.enabled:=false;
end;

procedure TEditorForm.BitBtn3Click(Sender: TObject);
begin
   mediaplayer1.filename:=verlorensoundedit.text;
   groupbox8.caption:='Sound abspielen: '+verzeichnis(verlorensoundedit.text)+' ';
   musikabspielen;
end;

procedure TEditorForm.BitBtn4Click(Sender: TObject);
begin
   mediaplayer1.filename:=siegsoundedit.text;
   groupbox8.caption:='Sound abspielen: '+verzeichnis(siegsoundedit.text)+' ';
   musikabspielen;
end;

procedure TEditorForm.BitBtn5Click(Sender: TObject);
begin
   mediaplayer1.filename:=explosionssoundedit.text;
   groupbox8.caption:='Sound abspielen: '+verzeichnis(explosionssoundedit.text)+' ';
   musikabspielen;
end;

procedure TEditorForm.BitBtn6Click(Sender: TObject);
begin
   mediaplayer1.filename:=schussstartsoundedit.text;
   groupbox8.caption:='Sound abspielen: '+verzeichnis(schussstartsoundedit.text)+' ';
   musikabspielen;
end;

procedure TEditorForm.SoundTimerTimer(Sender: TObject);
begin
 soundtrackbar.position:=mediaplayer1.position;
 if mediaplayer1.position>=mediaplayer1.length then
  begin
   mediaplayer1.stop;
   soundtrackbar.position:=0;
   soundtimer.enabled:=false;
  end;
end;

procedure TEditorForm.TextfarbeButtonClick(Sender: TObject);
begin
 if colordialog1.Execute then Label21.font.color:=ColorDialog1.Color;
end;

end.
