unit LadenUnit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TLadenForm = class(TForm)
    suchenButton: TButton;
    okButton: TButton;
    abbruchbuttonButton: TButton;
    Label1: TLabel;
    SzenarioComboBox: TComboBox;
    Label2: TLabel;
    suchenComboBox: TComboBox;
    Button1: TButton;
    hinzufuegenButton: TButton;
    procedure okButtonClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure suchenButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure abbruchbuttonButtonClick(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure hinzufuegenButtonClick(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  LadenForm: TLadenForm;

implementation

uses GamecreatorUnit1, Unit1;

{$R *.DFM}

procedure TLadenForm.okButtonClick(Sender: TObject);
begin
 dateiaktuell:=szenariocombobox.Text;
 Mainform.dateischreibensetup;
 mainform.dateiexlesen(dateiaktuell);

 Ladenform.visible:=false;
 Editorform.visible:=true;
end;

procedure TLadenForm.FormShow(Sender: TObject);
var use : t_Dzeiger;
begin
 use:=usedatei;
 szenariocombobox.Items.Clear;
 suchencombobox.text:='';
 szenariocombobox.Text:='';
 while use<>nil do   {schreibt alle Eintrge neu, den zeigern folgend}
 begin
   szenariocombobox.Items.add(use^.name);
   use:=use^.zeiger;
 end;

 szenariocombobox.text:=dateiaktuell;
 Label2.enabled:=false;
 suchencombobox.enabled:=false;
 hinzufuegenbutton.enabled:=false;
end;

procedure TLadenForm.suchenButtonClick(Sender: TObject);
 var dateien   : TSearchRec;
     vor, nach : T_Dzeiger;
     gefunden, gefunden2  : boolean;
begin
 suchencombobox.Items.clear;
 gefunden:=false;
 vor:=nil;
 nach:=usedatei;
 findfirst(extractFileDir(Application.EXEName)+'\*.cfg',faAnyFile,dateien);

    nach:=usedatei;
    gefunden2:=false;
    while (nach<>nil) and (gefunden2=false) do
    begin
      if uppercase(nach^.name)=uppercase(copy(dateien.name,1,length(dateien.name)-4)) then gefunden2:=true
      else nach:=nach^.zeiger;
    end;

    if (nach=nil) and (dateien.name<>'setup.cfg') then
    begin
     suchencombobox.Text:=dateien.name;
     suchencombobox.items.add(copy(dateien.name,1,length(dateien.name)-4{lscht .cfg }));
     gefunden:=true;
    end;

    while findnext(dateien)=0 do
      if dateien.attr <> faDirectory then
       begin
         nach:=usedatei;
         gefunden2:=false;
         while (nach<>nil) and (gefunden2=false) do
         begin
           if uppercase(nach^.name)=uppercase(copy(dateien.name,1,length(dateien.name)-4)) then gefunden2:=true
           else nach:=nach^.zeiger;
         end;

         if (nach=nil) and (dateien.name<>'setup.cfg') then
         begin
          suchencombobox.Text:=dateien.name;
          suchencombobox.items.add(copy(dateien.name,1,length(dateien.name)-4{lscht .cfg }));
          gefunden:=true;
         end;
       end;
   findclose(dateien);
 if gefunden then
 begin
 showmessage('Es wurden neue Szenarios gefunden!');
 hinzufuegenbutton.enabled:=true;
 label2.Enabled:=true;
 suchencombobox.enabled:=true;
 end
 else showmessage('Keine neuen Szenarios gefunden.');
end;

procedure TLadenForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
 Ladenform.visible:=false;
 Editorform.visible:=true;

end;

procedure TLadenForm.abbruchbuttonButtonClick(Sender: TObject);
begin
 ladenform.close;
end;

procedure TLadenForm.Button1Click(Sender: TObject);
begin
Showmessage('Diese Funktion durchsucht den Gamecreatorordner nach verlorengegangenen oder manuell hinzugefgten Szenarios.');
end;

procedure TLadenForm.hinzufuegenButtonClick(Sender: TObject);
var use : t_Dzeiger;
begin
 Mainform.neudateieintrag(suchencombobox.text);
 Mainform.dateischreibensetup;
 suchencombobox.clear;
 use:=usedatei;
 szenariocombobox.Items.Clear;
 while use<>nil do   {schreibt alle Eintrge neu, den zeigern folgend}
 begin
   szenariocombobox.Items.add(use^.name);
   use:=use^.zeiger;
 end;
 suchenbutton.click;

end;

end.
