unit speicherUnit2;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls;

type
  TSpeichernform = class(TForm)
    savegameEdit: TEdit;
    OKButton: TButton;
    AbbruchButton: TButton;
    Label1: TLabel;
    procedure AbbruchButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure OKButtonClick(Sender: TObject);
    procedure FormKeyPress(Sender: TObject; var Key: Char);
    procedure FormShow(Sender: TObject);
  private
    { Private-Deklarationen }
  public
    { Public-Deklarationen }
  end;

var
  Speichernform: TSpeichernform;

implementation

uses GamecreatorUnit1,Unit1;

{$R *.DFM}

procedure TSpeichernform.AbbruchButtonClick(Sender: TObject);
begin
 editorform.enabled:=true;
 speichernform.visible:=false;
end;

procedure TSpeichernform.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
 editorform.enabled:=true;
 speichernform.visible:=false;
 savegameedit.Focused;
end;

procedure TSpeichernform.OKButtonClick(Sender: TObject);
var i : integer;
    ueber, exist : boolean;
begin
{prft ob die datei schon existiert}
ueber:=true;
exist:=false;
if FileExists(extractfiledir(application.exename)+'\'+savegameedit.text+'.cfg')
 then
 begin
  if MessageDlg('Dieses Szenario existiert schon. Soll es berschrieben werden?',
  mtWarning, [mbYes, mbNo], 0) = mrYes then ueber:=true else ueber:=false;
  exist:=true;
 end;

if ueber then
 begin
  if not exist then Mainform.neudateieintrag(savegameedit.text);
  dateiaktuell:=savegameedit.text;

  editorform.enabled:=true;
  speichernform.visible:=false;

  highscore[1].punkte:=110;
  highscore[1].name:='MD-Technologie';
  highscore[1].schwierigkeitsgrad:=1;
  highscore[2].punkte:=12;
  highscore[2].name:='MD-Technologie';
  highscore[2].schwierigkeitsgrad:=1;
  highscore[3].punkte:=10;
  highscore[3].name:='MD-Technologie';
  highscore[3].schwierigkeitsgrad:=1;
  for i:=4 to 10 do
  begin
   highscore[i].punkte:=1;
   highscore[i].name:='MD-Technologie';
   highscore[i].schwierigkeitsgrad:=1;
  end;

  editorform.speichern(dateiaktuell);
 end;
end;

procedure TSpeichernform.FormKeyPress(Sender: TObject; var Key: Char);
begin
 if key=#13 then okbutton.Click;
end;

procedure TSpeichernform.FormShow(Sender: TObject);
begin
 savegameedit.text:='';
end;

end.
